var DEFAULT_TRANSPORTS, Model, Store, browserify, ioClient, socketio, uglify, util;
Model = require('./Model.server');
Store = require('./Store');
socketio = require('socket.io');
ioClient = require('socket.io-client');
browserify = require('browserify');
uglify = require('uglify-js');
util = require('./util');
DEFAULT_TRANSPORTS = ['websocket', 'xhr-polling'];
Store.prototype.setSockets = function(sockets, ioUri) {
  this.sockets = sockets;
  if (ioUri == null) {
    ioUri = '';
  }
  this._setSockets(this.sockets);
  return this._ioUri = ioUri;
};
Store.prototype.listen = function(to) {
  var io, socketUri;
  io = socketio.listen(to);
  io.configure(function() {
    io.set('browser client', false);
    return io.set('transports', DEFAULT_TRANSPORTS);
  });
  socketUri = typeof to === 'number' ? ':' + to : '';
  return this.setSockets(io.sockets, socketUri);
};
module.exports = {
  createStore: function(options) {
    var store;
    store = new Store(options);
    if (options.sockets) {
      store.setSockets(options.sockets, options.socketUri);
    } else if (options.listen) {
      store.listen(options.listen);
    }
    return store;
  },
  js: function(options, callback) {
    var minify, require, _ref;
    if (typeof options === 'function') {
      _ref = [options, {}], callback = _ref[0], options = _ref[1];
    }
    require = ['racer'];
    options.require = options.require ? require.concat(options.require) : require;
    if ((minify = options.minify) === void 0) {
      minify = true;
    }
    if (minify) {
      options.filter = uglify;
    }
    return ioClient.builder(DEFAULT_TRANSPORTS, {
      minify: minify
    }, function(err, value) {
      if (err) {
        throw err;
      }
      return callback(value + ';' + browserify.bundle(options));
    });
  },
  middleware: function(store) {
    return function(req, res, next) {
      var clientId, finish;
      if (!req.session) {
        throw 'Missing session middleware';
      }
      finish = function(clientId) {
        req.model = new Model(clientId);
        return next();
      };
      if (clientId = req.params.clientId || req.body.clientId) {
        return finish(clientId);
      } else {
        return store._nextClientId(finish);
      }
    };
  },
  util: util
};